package exemplos;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
public class ImageViewer extends JFrame implements ActionListener
  {
  private JMenuItem abrePNG, abreJPG, abreGIF;
  private JLabel imagem;
  private JScrollPane scrollImagem;
  public ImageViewer()
    {
    super("Exemplo de JMenus e JFileChooser");
    Container c = getContentPane();
    JMenuBar menuBar = new JMenuBar();
    // Criamos o menu "Abre"...
    JMenu menuAbre = new JMenu("Abre");
    abrePNG = new JMenuItem("Abre PNG");
    menuAbre.add(abrePNG);
    abrePNG.addActionListener(this);
    abreJPG = new JMenuItem("Abre JPG");
    menuAbre.add(abreJPG);
    abreJPG.addActionListener(this);
    abreGIF = new JMenuItem("Abre GIF");
    menuAbre.add(abreGIF);
    abreGIF.addActionListener(this);
    menuBar.add(menuAbre);
    setJMenuBar(menuBar);
    imagem = new JLabel();
    imagem.setHorizontalAlignment(SwingConstants.CENTER);
    scrollImagem = 
       new JScrollPane(imagem, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
                       JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
    scrollImagem.setPreferredSize(new Dimension(300, 300));
    c.add(scrollImagem);
    pack();
    setVisible(true);
    setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    }
  public void actionPerformed(ActionEvent e)
    {
    JFileChooser fc = new JFileChooser();
    if (e.getSource() == abrePNG) fc.setFileFilter(new FiltroPNG());
    if (e.getSource() == abreJPG) fc.setFileFilter(new FiltroJPG());
    if (e.getSource() == abreGIF) fc.setFileFilter(new FiltroGIF());
    int retorno = fc.showOpenDialog(this);
    if (retorno == JFileChooser.APPROVE_OPTION)
      {
      ImageIcon ícone = new ImageIcon(fc.getSelectedFile().toString());
      imagem.setIcon(ícone);
      scrollImagem.setPreferredSize(new Dimension(300, 300));
      scrollImagem.revalidate();
      }
    }
  public static void main(String[] args)
    {
    new ImageViewer();
    }
  }