package simpleinvaders1;

import java.awt.*;

import javax.swing.ImageIcon;

// Esta classe representa um tiro no jogo.
public class Bullet
  {
  // Posição do tiro em pixels.  
  private int x,y;
  // Este tiro está ativo?
  private boolean estáAtivo;
  // Tamanho do tiro em pixels.
  private int iw,ih;
  // Imagem do tiro.
  private Image icon;
  // Área do painel do jogo (para controlar movimento).  
  private Dimension area;
  
  // Construtor, inicializa atributos, cria a bala.
  public Bullet(Dimension a,Shooter s)
    {
    area = a;
    icon = new ImageIcon(getClass().getResource("/Sprites/bullet.png")).getImage();
    iw = icon.getWidth(null);
    ih = icon.getHeight(null);
    // x e y dependem do shooter
    x = s.getX();
    y = s.getY()-s.getHeight()/2;
    estáAtivo = true;
    }
  
  // Método que movimenta a bala.
  public void move()
    {
    if (!estáAtivo) return;
    y = y-3;
    if (y <= 0) estáAtivo = false;
    }
  
  // Método que desenha a bala em um contexto gráfico. 
  public void draw(Graphics g)
    {
    if (estáAtivo) g.drawImage(icon,x-iw/2,y-ih/2,null);
    }
  
  // Precisamos saber se esta bala está ativa!
  public boolean estáAtivo() { return estáAtivo; }

  // Verificamos se a bala está perto de um Invader
  public boolean acertouEm(Invader i)
    {
    int ox = i.getX(); int oy = i.getY();
    if (Math.sqrt((x-ox)*(x-ox)+(y-oy)*(y-oy)) < 10)
      {
      estáAtivo = false;
      return true;
      }
    else return false;
    }
  
  }